
WITH metu_egzemplioriai AS
(SELECT A.metai, COUNT(DISTINCT(B.nr)) AS egzemplioriai
FROM Stud.Knyga A
JOIN Stud.Egzempliorius B ON A.isbn = B.isbn
GROUP BY A.metai)

SELECT m.metai, m.egzemplioriai
FROM metu_egzemplioriai m
JOIN (
    SELECT MIN(egzemplioriai) AS min_egzemplioriai
    FROM metu_egzemplioriai
) min_count ON m.egzemplioriai = min_count.min_egzemplioriai;
