/* Processed by ecpg (15.5 (Debian 15.5-0+deb12u1)) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "Auction_demo.pgc"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

/* exec sql begin declare section */
  
 


#line 6 "Auction_demo.pgc"
 int result ;
 
#line 7 "Auction_demo.pgc"
 char pass [ 256 ] ;
/* exec sql end declare section */
#line 9 "Auction_demo.pgc"


// Pagalbines funkcijos
int isNumber(const char *str);
int containsOnlyLetters(const char *str);
void cleanBuffer();

//Duomenu manipuliavimo funkcijos
void naujasKainosSiulymas();
void pasalintiDaikta();
void idetiNaujaDaikta();
void uzregistruotiNaujaDalyvi();
void pakeistiAukcionoPavadinima();
void surastiDalyvi();
void rodytiDalyvioKainuSiulymus();

int main()
{
  printf("Programa pradeda darba\n") ;

  FILE *passwordFile = fopen("password.txt", "r");
    if (passwordFile == NULL)
    {
        fprintf(stderr, "Error opening password file.\n");
        return 1;
    }
  if (fgets(pass, sizeof(pass), passwordFile) != NULL)
    {
        pass[strcspn(pass, "\n")] = '\0';
    }

  fclose(passwordFile);

  { ECPGconnect(__LINE__, 0, "studentu@pgsql3.mif" , "magr9049" , pass , NULL, 0); }
#line 42 "Auction_demo.pgc"


  printf("CONNECTING TO DATABASE.\n");
  if( 0 == SQLCODE )
    printf("Programa veikia! SQLCODE=%ld\n Sėkmingai prisijungete prie aukciono!", SQLCODE);
  else
    printf("SQLCODE=%ld\n", SQLCODE );

  int choice;
    do
    {
        printf("\n1. Naujas kainos siūlymas\n");
        printf("2. Užregistruoti naują dalyvį\n");
        printf("3. Pridėti naują daiktą prie aukciono\n");
        printf("4. Pašalinti daiktą iš sąrašo\n");
        printf("5. Pakeisti aukciono pavadinimą\n");
	printf("6. Surasti dalyvį pagal vardą ir pavardę\n");
	printf("7. Rodyti visus dalyvio kainų siūlymus.\n");
	printf("0. Uždaryti programą\n");
        printf("Pasirinkite veiksmą: ");
        scanf("%d", &choice);

        switch (choice)
        {
        case 1:
            naujasKainosSiulymas();
            break;
        case 2:
            uzregistruotiNaujaDalyvi();
            break;
        case 3:
	    idetiNaujaDaikta();
            break;
        case 4:
            pasalintiDaikta();
            break;
	case 5:
	    pakeistiAukcionoPavadinima();
	    break;
	case 6:
	    surastiDalyvi();
	    break;
	case 7:
	    rodytiDalyvioKainuSiulymus();
	    break;
        case 0:
            break;
        default:
            printf("Neteisingas pasirinkimas.\n");
        }

    } while (choice != 0);

  { ECPGdisconnect(__LINE__, "CURRENT");}
#line 95 "Auction_demo.pgc"


  return 0 ;
}
// pagalbines funkcijos
void cleanBuffer()
{
   while (getchar() != '\n')
   {
   }
}

int isNumber(const char *str) {
    while (*str) {
        if (!isdigit(*str)) {
            return 0;  // Not a number
        }
        str++;
    }
    return 1;  // Contains only digits
}

int containsOnlyLetters(const char *str) {
    while (*str) {
        if (!isalpha(*str) && !isspace(*str)) {
            return 0;  // Not a letter
        }
        str++;
    }
    return 1;  // Contains only letters
}

// Duomenu manipuliavimo funkcijos
void naujasKainosSiulymas()
{
    /* exec sql begin declare section */
     
     
     
     
     
     
       // Taip arba Ne
     
    
#line 131 "Auction_demo.pgc"
 int dalyvio_id ;
 
#line 132 "Auction_demo.pgc"
 int dalyvis_id ;
 
#line 133 "Auction_demo.pgc"
 int daikto_id ;
 
#line 134 "Auction_demo.pgc"
 int dabartine_kaina ;
 
#line 135 "Auction_demo.pgc"
 int suma ;
 
#line 136 "Auction_demo.pgc"
 char pavadinimas [ 64 ] ;
 
#line 137 "Auction_demo.pgc"
 char ar_laimetojas [ 4 ] ;
 
#line 138 "Auction_demo.pgc"
 char yra_laimetojas [ 6 ] ;
/* exec sql end declare section */
#line 139 "Auction_demo.pgc"


    printf("Naujas kainos siulymas, pagal daikto ID (rodomi tik neparduoti daiktai):\n");
    /* exec sql whenever sqlerror  goto  sql_error ; */
#line 142 "Auction_demo.pgc"


    /* declare c_daiktai cursor for select Daikto_id , Pavadinimas from magr9049 . Daiktas */
#line 146 "Auction_demo.pgc"

        // WHERE Yra_parduotas = FALSE;
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_daiktai cursor for select Daikto_id , Pavadinimas from magr9049 . Daiktas", ECPGt_EOIT, ECPGt_EORT);
#line 148 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 148 "Auction_demo.pgc"


    printf("%-15s %-30s\n", "Daikto ID", "Pavadinimas");
    printf("=======================================\n");
    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_daiktai", ECPGt_EOIT, 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 154 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 154 "Auction_demo.pgc"


        if (SQLCODE == 0)
        {
            printf("%-15d %-30s\n", daikto_id, pavadinimas);
        }
    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_daiktai", ECPGt_EOIT, ECPGt_EORT);
#line 161 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 161 "Auction_demo.pgc"


    cleanBuffer();
    char input[20];
    printf("Įveskite Daikto ID iš sąrašo: ");
    scanf("%s", input);
    cleanBuffer();
    if (isNumber(input)) {
	daikto_id = atoi(input);
    } else {
	printf("Neteisingas formato Daikto ID.\n");
	return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select Pavadinimas , Kaina from magr9049 . Daiktas where Daikto_id = $1 ", 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_char,(pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(dabartine_kaina),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 177 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 177 "Auction_demo.pgc"

	
    if (SQLCODE == 0) {
	printf("Pasirinktas daiktas: %s\nDabartine kaina: %d\n", pavadinimas, dabartine_kaina);
    }else {
	printf("Įvyko klaida ieškant daikto. SQLCODE=%ld\n", SQLCODE);
	{ ECPGtrans(__LINE__, NULL, "rollback");
#line 183 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 183 "Auction_demo.pgc"
  // Rollback
	return;
    }

    printf("Įveskite Sumą: ");
    scanf("%s", input);
    cleanBuffer();
    if (isNumber(input)) {
       suma = atoi(input);
    } else {
       printf("Neteisingas formato Sumos įvedimas.\n");
       return;
    }


     /* declare c_dalyviai cursor for select Dalyvio_id from magr9049 . Dalyvis */
#line 200 "Auction_demo.pgc"

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_dalyviai cursor for select Dalyvio_id from magr9049 . Dalyvis", ECPGt_EOIT, ECPGt_EORT);
#line 201 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 201 "Auction_demo.pgc"


    printf("%-15s\n", "Dalyvio ID");
    printf("=======================================\n");
    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_dalyviai", ECPGt_EOIT, 
	ECPGt_int,&(dalyvis_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 207 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 207 "Auction_demo.pgc"

        if (SQLCODE == 0)
        {
            printf("%-15d\n", dalyvis_id);
        }
    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_dalyviai", ECPGt_EOIT, ECPGt_EORT);
#line 213 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 213 "Auction_demo.pgc"

    printf("Įveskite Dalyvio ID: ");
    scanf("%s", input);
    cleanBuffer();
    if (isNumber(input)) {
       dalyvio_id = atoi(input);
    } else {
       printf("Neteisingas formato Dalyvio ID įvedimas.\n");
       return;
    }

    printf("Ar tai yra laimėtas siūlymas? (Taip/Ne): ");
    scanf("%s", ar_laimetojas);

    char first_letter = toupper(ar_laimetojas[0]);
    strcpy(yra_laimetojas, (first_letter == 'T') ? "TRUE" : "FALSE");

    /* exec sql whenever sqlerror  goto  sql_error ; */
#line 230 "Auction_demo.pgc"


    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into magr9049 . Kainos_siulymai ( Dalyvio_id , Daikto_id , Suma , Yra_laimetojas ) values ( $1  , $2  , $3  , $4  )", 
	ECPGt_int,&(dalyvio_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(suma),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(yra_laimetojas),(long)6,(long)1,(6)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 233 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 233 "Auction_demo.pgc"


    if (SQLCODE != 0)
    {
        printf("Įvyko klaida įdedant naują kainos siūlymą. SQLCODE=%ld\n", SQLCODE);
        { ECPGtrans(__LINE__, NULL, "rollback");
#line 238 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 238 "Auction_demo.pgc"

        /* exec sql whenever sqlerror  continue ; */
#line 239 "Auction_demo.pgc"

        return;
    }

    if (first_letter == 'T')
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update magr9049 . Daiktas set Yra_parduotas = true where Daikto_id = $1 ", 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 247 "Auction_demo.pgc"


        if (SQLCODE != 0)
        {
            printf("Įvyko klaida pažymint daiktą kaip parduotą. SQLCODE=%ld\n", SQLCODE);
            { ECPGtrans(__LINE__, NULL, "rollback");}
#line 252 "Auction_demo.pgc"
  // Rollback, nes sekmingai ivykditas tik vienas sql sakinys
            /* exec sql whenever sqlerror  continue ; */
#line 253 "Auction_demo.pgc"

            return;
        }

        printf("Daiktas pažymėtas kaip parduotas.\n");
    }

    // viskas ivykdita sekmingai
    { ECPGtrans(__LINE__, NULL, "commit");}
#line 261 "Auction_demo.pgc"
 

    printf("Naujas kainos siūlymas sėkmingai įvestas.\n");

    /* exec sql whenever sqlerror  continue ; */
#line 265 "Auction_demo.pgc"

    return;

sql_error:
    printf("Įvyko klaida įdedant naują kainos siūlymą. SQLCODE=%ld\n", SQLCODE);
    { ECPGtrans(__LINE__, NULL, "rollback");}
#line 270 "Auction_demo.pgc"
 
    /* exec sql whenever sqlerror  continue ; */
#line 271 "Auction_demo.pgc"

}

void uzregistruotiNaujaDalyvi()
{
    /* exec sql begin declare section */
     
     
    
#line 277 "Auction_demo.pgc"
 char vardas [ 64 ] ;
 
#line 278 "Auction_demo.pgc"
 char pavarde [ 64 ] ;
/* exec sql end declare section */
#line 279 "Auction_demo.pgc"


    printf("Įveskite dalyvio vardą: ");
    scanf("%s", vardas);
    cleanBuffer();
    if (!containsOnlyLetters(vardas)) {
        printf("Klaidingas vardo įvedimas.\n");
        return;
    }

    printf("Įveskite dalyvio pavardę: ");
    scanf("%s", pavarde);
    cleanBuffer();
    if (!containsOnlyLetters(pavarde)) {
        printf("Klaidingas pavardės įvedimas.\n");
        return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into magr9049 . Dalyvis ( Vardas , Pavarde ) values ( $1  , $2  )", 
	ECPGt_char,(vardas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavarde),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 298 "Auction_demo.pgc"


    if (SQLCODE == 0)
    {
        printf("Naujas dalyvis užregistruotas sėkmingai.\n");
        { ECPGtrans(__LINE__, NULL, "commit");}
#line 303 "Auction_demo.pgc"

    }
    else
    {
        printf("Įvyko klaida registruojant naują dalyvį. SQLCODE=%ld\n", SQLCODE);
    }

    /* exec sql whenever sqlerror  continue ; */
#line 310 "Auction_demo.pgc"

    return;
}

void pakeistiAukcionoPavadinima()
{
    /* exec sql begin declare section */
     
     
     
    
#line 317 "Auction_demo.pgc"
 int aukciono_id ;
 
#line 318 "Auction_demo.pgc"
 char dabartinis_pavadinimas [ 64 ] ;
 
#line 319 "Auction_demo.pgc"
 char naujas_pavadinimas [ 64 ] ;
/* exec sql end declare section */
#line 320 "Auction_demo.pgc"


    printf("Visi aukcionai:\n");
    /* exec sql whenever sqlerror  goto  sql_error ; */
#line 323 "Auction_demo.pgc"


    /* declare c_auction cursor for select Aukciono_id , Pavadinimas from magr9049 . Aukcionas */
#line 327 "Auction_demo.pgc"

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_auction cursor for select Aukciono_id , Pavadinimas from magr9049 . Aukcionas", ECPGt_EOIT, ECPGt_EORT);
#line 328 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 328 "Auction_demo.pgc"


    printf("%-15s %-30s\n", "Aukciono ID", "Pavadinimas");
    printf("=======================================\n");
    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_auction", ECPGt_EOIT, 
	ECPGt_int,&(aukciono_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(dabartinis_pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 334 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 334 "Auction_demo.pgc"


        if (SQLCODE == 0)
        {
            printf("%-15d %-30s\n", aukciono_id, dabartinis_pavadinimas);
        }
    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_auction", ECPGt_EOIT, ECPGt_EORT);
#line 341 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 341 "Auction_demo.pgc"


    printf("Įveskite Aukciono ID: ");
    char input[20];
    scanf("%s", input);
    cleanBuffer();

    if (isNumber(input)) {
        aukciono_id = atoi(input);  
        printf("Aukciono ID: %d\n", aukciono_id);
    } else {
        printf("Neteisingas įvesties formatas. Įveskite skaičių.\n");
	return;    
    }    
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select Pavadinimas from magr9049 . Aukcionas where Aukciono_id = $1 ", 
	ECPGt_int,&(aukciono_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_char,(dabartinis_pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 357 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 357 "Auction_demo.pgc"


    if (SQLCODE != 0)
    {
        printf("Aukcionas su ID %d neegzistuoja.\n", aukciono_id);
        return;
    }

    printf("Dabartinis pavadinimas: %s\n", dabartinis_pavadinimas);

    printf("Įveskite naują aukciono pavadinimą: ");
    scanf("%[^\n]s", naujas_pavadinimas);
    cleanBuffer();
    if (containsOnlyLetters(naujas_pavadinimas) == 0)
    {
        printf("Neteisingas pavadinimo formatas. Leidžiamos tik raidės.\n");
        return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "update magr9049 . Aukcionas set Pavadinimas = $1  where Aukciono_id = $2 ", 
	ECPGt_char,(naujas_pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(aukciono_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 378 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 378 "Auction_demo.pgc"


    if (SQLCODE == 0)
    {
        printf("Aukciono pavadinimas sėkmingai pakeistas.\n");
        { ECPGtrans(__LINE__, NULL, "commit");
#line 383 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 383 "Auction_demo.pgc"
  // Commit if the update is successful
    }
    else
    {
        printf("Įvyko klaida keičiant aukciono pavadinimą. SQLCODE=%ld\n", SQLCODE);
    }

    /* exec sql whenever sqlerror  continue ; */
#line 390 "Auction_demo.pgc"

    return;

sql_error:
    printf("Įvyko klaida. SQLCODE=%ld\n", SQLCODE);
    { ECPGtrans(__LINE__, NULL, "rollback");}
#line 395 "Auction_demo.pgc"

}

void idetiNaujaDaikta()
{
    /* exec sql begin declare section */
     
     
     
     
    
#line 401 "Auction_demo.pgc"
 char pavadinimas [ 64 ] ;
 
#line 402 "Auction_demo.pgc"
 double pradine_kaina ;
 
#line 403 "Auction_demo.pgc"
 int aukciono_id ;
 
#line 404 "Auction_demo.pgc"
 char aukciono_pavadinimas [ 64 ] ;
/* exec sql end declare section */
#line 405 "Auction_demo.pgc"


    cleanBuffer();
    printf("Įveskite Daikto pavadinimą: ");
    scanf("%[^\n]s", pavadinimas);
    cleanBuffer();
    printf("Įveskite Pradinę Daikto kainą: ");
    char kaina_input[20];
    scanf("%s", kaina_input);
    if (isNumber(kaina_input)) {
        pradine_kaina = atof(kaina_input);
    } else {
        printf("Neteisingas įvesties formatas. Įveskite skaičių.\n");
        return;
    }
    cleanBuffer();
    printf("Įveskite Aukciono ID, kuriam priklauso šis Daiktas: ");
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_auction cursor for select Aukciono_id , Pavadinimas from magr9049 . Aukcionas", ECPGt_EOIT, ECPGt_EORT);}
#line 422 "Auction_demo.pgc"


    printf("%-15s %-30s\n", "Aukciono ID", "Pavadinimas");
    printf("=======================================\n");
    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_auction", ECPGt_EOIT, 
	ECPGt_int,&(aukciono_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(aukciono_pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
#line 428 "Auction_demo.pgc"


        if (SQLCODE == 0)
        {
            printf("%-15d %-30s\n", aukciono_id, aukciono_pavadinimas);
        }
    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_auction", ECPGt_EOIT, ECPGt_EORT);}
#line 435 "Auction_demo.pgc"

    char aukciono_id_input[20];
    scanf("%s", aukciono_id_input);

    if (isNumber(aukciono_id_input)) {
        aukciono_id = atoi(aukciono_id_input);
    } else {
        printf("Neteisingas įvesties formatas. Įveskite skaičių.\n");
        return;
    }
    cleanBuffer();
    // ivedimas
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "insert into magr9049 . Daiktas ( Aukciono_id , Pavadinimas , Kaina ) values ( $1  , $2  , $3  )", 
	ECPGt_int,&(aukciono_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_double,&(pradine_kaina),(long)1,(long)1,sizeof(double), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);}
#line 448 "Auction_demo.pgc"


    if (SQLCODE == 0)
    {
        printf("Naujas Daiktas įvestas sėkmingai.\n");
        { ECPGtrans(__LINE__, NULL, "commit");}
#line 453 "Auction_demo.pgc"
  // Commit if the insertion is successful
    }
    else
    {
        printf("Įvyko klaida įdedant naują Daiktą. SQLCODE=%ld\n", SQLCODE);
        
    }

    /* exec sql whenever sqlerror  continue ; */
#line 461 "Auction_demo.pgc"

    return;
}

void pasalintiDaikta()
{
    /* exec sql begin declare section */
     
     
     
    
#line 468 "Auction_demo.pgc"
 int daikto_id ;
 
#line 469 "Auction_demo.pgc"
 char pavadinimas [ 64 ] ;
 
#line 470 "Auction_demo.pgc"
 int result ;
/* exec sql end declare section */
#line 471 "Auction_demo.pgc"


    printf("Daiktai:\n");
    /* exec sql whenever sqlerror  goto  sql_error ; */
#line 474 "Auction_demo.pgc"


    /* declare c_items cursor for select Daikto_id , Pavadinimas from magr9049 . Daiktas */
#line 478 "Auction_demo.pgc"

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_items cursor for select Daikto_id , Pavadinimas from magr9049 . Daiktas", ECPGt_EOIT, ECPGt_EORT);
#line 479 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 479 "Auction_demo.pgc"


    printf("%-15s %-30s\n", "Daikto ID", "Pavadinimas");
    printf("=======================================\n");
    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_items", ECPGt_EOIT, 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 485 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 485 "Auction_demo.pgc"

        if (SQLCODE == 0)
        {
            printf("%-15d %-30s\n", daikto_id, pavadinimas);
        }
    }
    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_items", ECPGt_EOIT, ECPGt_EORT);
#line 491 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 491 "Auction_demo.pgc"


    printf("Iveskite Daikto ID, kuri norite pasalinti: ");
    char input[20];
    scanf("%s", input);
    cleanBuffer();

    if (isNumber(input)) {
        daikto_id = atoi(input);
    } else {
        printf("Neteisingas įvesties formatas. Įveskite skaičių.\n");
        return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select count ( * ) from magr9049 . Daiktas where Daikto_id = $1 ", 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(result),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 507 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 507 "Auction_demo.pgc"

    if (result == 0)
    {
        printf("Daiktas su ID %d neegzistuoja.\n", daikto_id);
        return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from magr9049 . Kainos_siulymai where Daikto_id = $1 ", 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 515 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 515 "Auction_demo.pgc"


    if (SQLCODE != 0 && SQLCODE != 100)
    {
        printf("Įvyko klaida pašalinant pasiūlymus. SQLCODE=%ld\n", SQLCODE);
        { ECPGtrans(__LINE__, NULL, "rollback");
#line 520 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 520 "Auction_demo.pgc"

        return;
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "delete from magr9049 . Daiktas where Daikto_id = $1 ", 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 525 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 525 "Auction_demo.pgc"


    if (SQLCODE != 0)
    {
        printf("Įvyko klaida pašalinant daiktą. SQLCODE=%ld\n", SQLCODE);
        { ECPGtrans(__LINE__, NULL, "rollback");
#line 530 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 530 "Auction_demo.pgc"

        return;
    }

    { ECPGtrans(__LINE__, NULL, "commit");
#line 534 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 534 "Auction_demo.pgc"


    printf("Daiktas ir susiję pasiūlymai pašalinti sėkmingai.\n");
    return;

sql_error:
    printf("Įvyko klaida. SQLCODE=%ld\n", SQLCODE);
    { ECPGtrans(__LINE__, NULL, "rollback");
#line 541 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 541 "Auction_demo.pgc"

}

void surastiDalyvi()
{
    /* exec sql begin declare section */
     
     
     
    
#line 547 "Auction_demo.pgc"
 int dalyvio_id ;
 
#line 548 "Auction_demo.pgc"
 char vardas [ 64 ] ;
 
#line 549 "Auction_demo.pgc"
 char pavarde [ 64 ] ;
/* exec sql end declare section */
#line 550 "Auction_demo.pgc"


    printf("Įveskite dalyvio vardą: ");
    scanf("%63s", vardas);
    if (containsOnlyLetters(vardas) == 0)
    {
        printf("Vardas gali turėti tik raides.\n");
        return;
    }
    cleanBuffer();
    printf("Įveskite dalyvio pavardę: ");
    scanf("%63s", pavarde);
    if (containsOnlyLetters(pavarde) == 0)
    {
        printf("Pavardė gali turėti tik raides.\n");
        return;
    }
    cleanBuffer();

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select Dalyvio_id from magr9049 . Dalyvis where UPPER ( Vardas ) = UPPER ( $1  ) and UPPER ( Pavarde ) = UPPER ( $2  )", 
	ECPGt_char,(vardas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavarde),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
	ECPGt_int,&(dalyvio_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 571 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 571 "Auction_demo.pgc"


    if (SQLCODE == 0)
    {
	printf("%-15s %-30s %-30s\n", "Dalyvio ID", "Vardas", "Pavardė");
	printf("==============================================================\n");
	printf("%-15d %-30s %-30s\n", dalyvio_id, vardas, pavarde);
    }
    else
    {
	if (SQLCODE == 1403)
	{
            printf("Dalyvis su vardu '%s' ir pavardė '%s' nerastas.\n", vardas, pavarde);
	}
	else
	{
            printf("Įvyko klaida ieškant dalyvio. SQLCODE=%ld\n", SQLCODE);
	}
    }
  sql_error:
}

void rodytiDalyvioKainuSiulymus()
{
    /* exec sql begin declare section */
     
     
     
     
     
     
    
#line 596 "Auction_demo.pgc"
 int dalyvio_id ;
 
#line 597 "Auction_demo.pgc"
 char vardas [ 64 ] ;
 
#line 598 "Auction_demo.pgc"
 char pavarde [ 64 ] ;
 
#line 599 "Auction_demo.pgc"
 int daikto_id ;
 
#line 600 "Auction_demo.pgc"
 int suma ;
 
#line 601 "Auction_demo.pgc"
 char pavadinimas [ 64 ] ;
/* exec sql end declare section */
#line 602 "Auction_demo.pgc"


    cleanBuffer();
    char input[20];
    printf("Įveskite dalyvio ID: ");
    scanf("%s", input);
    cleanBuffer();

    if (isNumber(input)) {
        dalyvio_id = atoi(input);
    } else {
        printf("Neteisingas formato dalyvio ID.\n");
        return;
    }

    /* exec sql whenever sqlerror  goto  sql_error ; */
#line 617 "Auction_demo.pgc"


    ECPGset_var( 0, &( dalyvio_id ), __LINE__);\
 /* declare c_kainos cursor for select D . Dalyvio_id , D . Vardas , D . Pavarde , K . Daikto_id , K . Suma , DT . Pavadinimas from magr9049 . Dalyvis D join magr9049 . Kainos_siulymai K on D . Dalyvio_id = K . Dalyvio_id join magr9049 . Daiktas DT on K . Daikto_id = DT . Daikto_id where D . Dalyvio_id = $1  */
#line 624 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;
#line 624 "Auction_demo.pgc"

#line 624 "Auction_demo.pgc"

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "declare c_kainos cursor for select D . Dalyvio_id , D . Vardas , D . Pavarde , K . Daikto_id , K . Suma , DT . Pavadinimas from magr9049 . Dalyvis D join magr9049 . Kainos_siulymai K on D . Dalyvio_id = K . Dalyvio_id join magr9049 . Daiktas DT on K . Daikto_id = DT . Daikto_id where D . Dalyvio_id = $1 ", 
	ECPGt_int,&(dalyvio_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 625 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 625 "Auction_demo.pgc"


    printf("%-15s %-30s %-30s %-15s %-15s %-30s\n", "Dalyvio ID", "Vardas", "Pavardė", "Daikto ID", "Suma", "Pavadinimas");
    printf("===============================================================================================================\n");

    while (SQLCODE == 0)
    {
        { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "fetch c_kainos", ECPGt_EOIT, 
	ECPGt_int,&(dalyvio_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(vardas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavarde),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(daikto_id),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_int,&(suma),(long)1,(long)1,sizeof(int), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,(pavadinimas),(long)64,(long)1,(64)*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 632 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 632 "Auction_demo.pgc"


        if (SQLCODE == 0)
        {
            printf("%-15d %-30s %-30s %-15d %-15d %-30s\n", dalyvio_id, vardas, pavarde, daikto_id, suma, pavadinimas);
        }
    }

    { ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "close c_kainos", ECPGt_EOIT, ECPGt_EORT);
#line 640 "Auction_demo.pgc"

if (sqlca.sqlcode < 0) goto sql_error;}
#line 640 "Auction_demo.pgc"


    if (SQLCODE != 0)
    {
        printf("Įvyko klaida ieškant dalyvio kainų siūlymų. SQLCODE=%ld\n", SQLCODE);
        /* exec sql whenever sqlerror  continue ; */
#line 645 "Auction_demo.pgc"

        return;
    }

    /* exec sql whenever sqlerror  continue ; */
#line 649 "Auction_demo.pgc"

    return;

sql_error:
    printf("Įvyko klaida. SQLCODE=%ld\n", SQLCODE);
    /* exec sql whenever sqlerror  continue ; */
#line 654 "Auction_demo.pgc"

}

