WITH negrazintos_knygos AS (
SELECT COUNT(B.nr) AS borrowed_count
FROM Stud.Skaitytojas A
JOIN Stud.Egzempliorius B ON A.nr = B.Skaitytojas
WHERE (B.grazinti > CURRENT_DATE)),
visos_knygos AS (
SELECT COUNT(B.nr) AS all_count
FROM negrazintos_knygos C, Stud.Skaitytojas A
JOIN Stud.Egzempliorius B ON A.nr = B.Skaitytojas)

SELECT CAST(B.borrowed_count AS DECIMAL) / A.all_count
FROM negrazintos_knygos B, visos_knygos A;


