SELECT table_schema,
       table_name,
       COUNT(position_in_unique_constraint) AS num_foreign_keys
FROM information_schema.key_column_usage
WHERE position_in_unique_constraint IS NOT NULL
GROUP BY table_schema, table_name
HAVING COUNT(position_in_unique_constraint) > 1;
