/* JOIN, SELECT, FROM, WHERE (is not null), ORDER BY, DESC
   DISTINCT, LOWER*/

/*SELECT * FROM stud.autorius;
SELECT * FROM stud.knyga;
SELECT metai FROM stud.knyga;
SELECT pavadinimas,leidykla,metai FROM stud.knyga
WHERE stud.knyga.metai < 2018;
*/
/* magr // 1 uzd
SELECT pavadinimas,leidykla,metai FROM stud.knyga
WHERE metai < 2018;
*/

/* // 2 uzd
SELECT  A.nr,A.paimta,A.grazinti,B.ak,B.pavarde
FROM stud.egzempliorius A JOIN stud.skaitytojas B
ON A.skaitytojas = B.NR
WHERE A.paimta < CURRENT_DATE AND A.grazinti IS NOT NULL;
*/

/* joli // 1 uzd
SELECT DISTINCT A.ISBN FROM stud.knyga A JOIN stud.egzempliorius B
ON A.ISBN = B.ISBN
WHERE B.skaitytojas IS NULL;
*/

/* // 2 uzd
SELECT A.vardas,A.pavarde FROM stud.skaitytojas A
JOIN stud.egzempliorius B ON A.NR = B.skaitytojas
JOIN stud.knyga C ON B.ISBN = C.ISBN
WHERE C.pavadinimas = 'Duomenu bazes';
*/

/* // 1 uzd
SELECT grazinti FROM stud.egzempliorius
WHERE grazinti IS NOT NULL;
*/

/* // 2 uzd
SELECT leidykla FROM stud.autorius A JOIN stud.knyga B
ON A.ISBN = B.ISBN
WHERE A.vardas = 'Jonas' AND A.pavarde = 'Petraitis';
*/
/*
SELECT pavarde,((CURRENT_DATE - gimimas) / 365) AS "Amzius"
FROM stud.skaitytojas WHERE vardas = 'Jonas';
*/


SELECT COUNT(DISTINCT A.isbn) AS "Atitinka",
COUNT(A.isbn) AS "Egzemplioriai",
COUNT(C.vardas) AS "Skaitomi",
COUNT(CASE WHEN C.vardas IS NULL THEN 'foo' ELSE NULL END) AS "Neskaitomi"
FROM (stud.knyga A JOIN stud.egzempliorius B ON A.isbn = B.isbn)
LEFT OUTER JOIN stud.skaitytojas C ON C.nr = B.skaitytojas
WHERE LOWER(A.Leidykla)='baltoji' OR A.metai=2017;
