SELECT S.Vardas, S.Pavarde, COUNT(E.Nr) AS Negrąžintų_egzempliorių_skaičius
FROM Stud.Skaitytojas S
JOIN Stud.Egzempliorius E ON S.Nr = E.Skaitytojas
GROUP BY S.Vardas, S.Pavarde
HAVING COUNT(E.Nr) > (
    SELECT AVG(subquery_counts.count)
    FROM (
        SELECT COUNT(E2.Nr) as count
        FROM Stud.Skaitytojas S2
        JOIN Stud.Egzempliorius E2 ON S2.Nr = E2.Skaitytojas
        GROUP BY S2.Nr
    ) AS subquery_counts
);
