SELECT S.Vardas, S.Pavarde, COUNT(E.Nr) AS negrazinti_egzemp
FROM Stud.Skaitytojas S
LEFT JOIN Stud.Egzempliorius E ON S.Nr = E.Skaitytojas
GROUP BY S.Nr
HAVING COUNT(E.Nr) > (
    SELECT AVG(subquery.negrazinti)
    FROM (
        SELECT COUNT(E2.Nr) as negrazinti
        FROM Stud.Skaitytojas S2
        LEFT JOIN Stud.Egzempliorius E2 ON S2.Nr = E2.Skaitytojas
        GROUP BY S2.Nr
    ) AS subquery
);
